#ifndef NULLSOFT_API_PLAYLISTDIRECTORYCALLBACK_H
#define NULLSOFT_API_PLAYLISTDIRECTORYCALLBACK_H

#include <bfc/dispatch.h>
#include <bfc/platform/types.h>

class api_playlistdirectorycallback : public Dispatchable
{
protected:
	api_playlistdirectorycallback() {}
	~api_playlistdirectorycallback() {}
public:
	bool ShouldRecurse(const wchar_t *path);
	bool ShouldLoad(const wchar_t *filename);
public:
	DISPATCH_CODES
	{
		API_PLAYLISTDIRECTORYCALLBACK_SHOULDRECURSE = 10,
			API_PLAYLISTDIRECTORYCALLBACK_SHOULDLOAD = 20,
	};
};

inline bool api_playlistdirectorycallback::ShouldRecurse(const wchar_t *path)
{
	return _call(API_PLAYLISTDIRECTORYCALLBACK_SHOULDRECURSE, (bool)false, path);
}

inline bool api_playlistdirectorycallback::ShouldLoad(const wchar_t *filename)
{
	return _call(API_PLAYLISTDIRECTORYCALLBACK_SHOULDLOAD, (bool)true, filename);
}

#endif