// SettingsDialogOutput.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogOutput.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "volume.h"
#include "In/MultiDllInput.h"
#include "out/MultiDllOutput.h"
#include "WAEmuwnd.h"
#include "in/CommonFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogOutput

IMPLEMENT_MENUXP(CSettingsDialogOutput, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogOutput, CPropertyPage)

CSettingsDialogOutput::CSettingsDialogOutput() : CPropertyPage(CSettingsDialogOutput::IDD)
{
	m_current = -1;
	updateOnly = false;
}

CSettingsDialogOutput::~CSettingsDialogOutput()
{
}

void CSettingsDialogOutput::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_ABOUT_OUTPUT, m_btnAbout);
	DDX_Control(pDX, IDC_CONFIG_OUTPUT, m_btnConfiguration);
	DDX_Control(pDX, IDC_LOAD_OUTPUT, m_btnLoad);
	DDX_Control(pDX, IDC_UNLOAD_OUTPUT, m_btnUnload);
	DDX_Control(pDX, IDC_LIST_OUTPUT, m_ListOutput);
	DDX_Control(pDX, IDC_SPIN3, m_Spin);
	DDX_Control(pDX, IDC_QUERY, m_btnQuery);
}

BOOL CSettingsDialogOutput::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_Helper.translateDlgItemText(this, IDC_CONFIG_OUTPUT);
	m_Helper.translateDlgItemText(this, IDC_ABOUT_OUTPUT);
	m_Helper.translateDlgItemText(this, IDC_LOAD_OUTPUT);
	m_Helper.translateDlgItemText(this, IDC_UNLOAD_OUTPUT);
	m_Helper.translateDlgItemText(this, IDC_LMIXERDEVICE);
	m_Helper.translateDlgItemText(this, IDC_LCDLETTER);
	m_Helper.translateDlgItemText(this, IDC_LFREEDBSERVER);
	m_Helper.translateDlgItemText(this, IDC_LYOURMAIL);
	m_Helper.translateDlgItemText(this, IDC_QUERY);
	m_Helper.translateDlgItemText(this, IDC_AUTOCDDB);
	m_Spin.SetRange(0, stdOut->GetSize() - 1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CSettingsDialogOutput::OnSetActive()
{
	while (m_ListOutput.GetCount() != 0)
	{
		m_ListOutput.DeleteString(0);
	}
	for (int i = 0; i < stdOut->GetSize(); i++)
	{
		CDllOutput* output = stdOut->getDllOutput(i);
		CString desc = _T("");
		TCHAR descTCHAR[500];
		Strcpy(descTCHAR, 500, output->GetDescription());
		desc.Format(_T("%s (%s)"), descTCHAR, output->GetFileName());
		m_ListOutput.AddString(desc);
		if (stdOut->GetOut_Module() == output->GetOut_Module())
		{
			m_ListOutput.SetCurSel(i);
			m_Spin.SetPos(stdOut->GetSize() - i);
			m_current = i;
		}
	}
	return TRUE;
}

void CSettingsDialogOutput::OnOK()
{
	UpdateData(TRUE);
	CString dllOutKey = _T("");
	for (int i = 0; i < stdOut->GetSize(); i++)
	{
		CDllOutput* output = stdOut->getDllOutput(i);
		dllOutKey.Format(_T("dllOutName%d"), i);
		AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, output->GetFilePath());
	}
	dllOutKey.Format(_T("dllOutName%d"), stdOut->GetSize());
	AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, _T("NONE"));
	CPropertyPage::OnOK();
}
BEGIN_MESSAGE_MAP(CSettingsDialogOutput, CPropertyPage)
  ON_BN_CLICKED(IDC_CONFIG_OUTPUT, OnBnClickedConfig)
  ON_BN_CLICKED(IDC_ABOUT_OUTPUT, OnBnClickedAbout)
  ON_BN_CLICKED(IDC_LOAD_OUTPUT, OnBnClickedLoad)
  ON_BN_CLICKED(IDC_UNLOAD_OUTPUT, OnBnClickedUnload)
  ON_EN_CHANGE(IDC_EDIT2,OnSpinChange)
  ON_LBN_SELCHANGE(IDC_LIST_OUTPUT,OnListChange)
  ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogOutput
void CSettingsDialogOutput::OnBnClickedConfig()
{
	for (int i = stdOut->GetSize() - 1; i >= 0; i--)
	{
		if (m_ListOutput.GetSel(i) != 0)
		{
			CDllOutput* output = stdOut->getDllOutput(i);
			output->Config(this->GetParent()->GetParent()->m_hWnd);
		}
	}
}

void CSettingsDialogOutput::OnBnClickedAbout()
{
	for (int i = stdOut->GetSize() - 1; i >= 0; i--)
	{
		if (m_ListOutput.GetSel(i) != 0)
		{
			CDllOutput* output = stdOut->getDllOutput(i);
			output->About(this->GetParent()->GetParent()->m_hWnd);
		}
	}
}

void CSettingsDialogOutput::OnBnClickedLoad()
{
	CString filter = "";
	CFileDialog dialog(TRUE, _T("dll"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENOUTPUT));
	TCHAR buffer[_MAX_PATH*500 + 1];
	buffer[0] = '\0';
	dialog.m_ofn.lpstrFile = buffer;
	dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
	if (dialog.DoModal() == IDOK)
	{
		int oldSize = stdOut->GetSize();
		stdOut->Load(dialog.GetPathName(), WAEmuWnd->m_hWnd);
		if (oldSize != stdOut->GetSize())
		{
			CDllOutput* output = stdOut->getDllOutput(oldSize);
			CString desc = _T("");
			TCHAR descTCHAR[500];
			Strcpy(descTCHAR, 500, output->GetDescription());
			desc.Format(_T("%s (%s)"), descTCHAR, output->GetFileName());
			m_ListOutput.AddString(desc);
			m_Spin.SetRange(0, stdOut->GetSize() - 1);
		}
	}
}

void CSettingsDialogOutput::OnBnClickedUnload()
{
	if (-1 < m_ListOutput.GetCurSel() && m_ListOutput.GetCurSel() < stdOut->GetSize())
	{
		int index = m_ListOutput.GetCurSel();
		CDllOutput* output = stdOut->getDllOutput(index);
		if (output->GetFilePath() != "STANDARD")
		{
			if (output->GetOut_Module() == stdOut->GetOut_Module() && stdIn->GetPlayerMode() != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			stdOut->UnLoad(index);
			m_ListOutput.DeleteString(index);
			m_Spin.SetRange(0, stdOut->GetSize() - 1);
			m_current = -1;
			m_ListOutput.SetCurSel(m_current);
			stdIn->SetOutMod(stdOut->GetOut_Module());
		}
	}
}

void CSettingsDialogOutput::OnSpinChange()
{
	if (!updateOnly && m_current != -1)
	{
		if (m_current >= 0 && m_current <= stdOut->GetSize() - 1)
		{
			if (m_current > m_Spin.GetPos())
			{
				stdOut->UpDllOutput(m_current);
				CDllOutput* output = stdOut->getDllOutput(m_current);
				CString desc = "";
				TCHAR descTCHAR[500];
				Strcpy(descTCHAR, 500, output->GetDescription());
				desc.Format(_T("%s (%s)"), descTCHAR, output->GetFileName());
				m_ListOutput.DeleteString(m_Spin.GetPos());
				m_ListOutput.InsertString(m_current, desc);
			}
			else
			{
				stdOut->UpDllOutput(m_Spin.GetPos());
				CDllOutput* output = stdOut->getDllOutput(m_current);
				CString desc = "";
				TCHAR descTCHAR[500];
				Strcpy(descTCHAR, 500, output->GetDescription());
				desc.Format(_T("%s (%s)"), descTCHAR, output->GetFileName());
				m_ListOutput.DeleteString(m_Spin.GetPos());
				m_ListOutput.InsertString(m_current, desc);
			}
			m_current = m_Spin.GetPos();
			m_ListOutput.SetCurSel(m_current);
		}
	}
	updateOnly = false;
}

void CSettingsDialogOutput::OnListChange()
{
	m_current = m_ListOutput.GetCurSel();
	updateOnly = true;
	m_Spin.SetPos(m_current);
}
