// SettingsDialogW2File.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "systrayplay.h"
#include "SettingsDialogW2File.h"
#include "MainWnd.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogW2File dialog
//IMPLEMENT_MENUXP(CSettingsDialogW2File, CPropertyPage);
//IMPLEMENT_DYNAMIC(CSettingsDialogW2File, CPropertyPage)


CSettingsDialogW2File::CSettingsDialogW2File() : CPropertyPage(CSettingsDialogW2File::IDD)
{
	//{{AFX_DATA_INIT(CSettingsDialogW2File)
	m_del = FALSE;
	m_exit = _T("");
	m_file = _T("");
	m_oem = FALSE;
	m_pause = _T("");
	m_play = _T("");
	m_stop = _T("");
	m_enabled = FALSE;
	m_Ftp = FALSE;
	//}}AFX_DATA_INIT

}


void CSettingsDialogW2File::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_W2FBROWSE, m_btnBrowse);
	DDX_Check(pDX, IDC_W2FDELONEXIT, m_del);
	DDX_Text(pDX, IDC_W2FEXIT, m_exit);
	DDX_Text(pDX, IDC_W2FFILE, m_file);
	DDX_Check(pDX, IDC_W2FOEM, m_oem);
	DDX_Text(pDX, IDC_W2FPAUSE, m_pause);
	DDX_Text(pDX, IDC_W2FPLAY, m_play);
	DDX_Text(pDX, IDC_W2FSTOP, m_stop);
	DDX_Check(pDX, IDC_W2FENABLE, m_enabled);
	DDX_Check(pDX, IDC_W2FFTP, m_Ftp);
	DDX_Text(pDX, IDC_W2FSITE, m_Site);
	DDX_Text(pDX, IDC_W2FUSER, m_User);
	DDX_Text(pDX, IDC_W2FPASSWORD, m_Password);
}


BEGIN_MESSAGE_MAP(CSettingsDialogW2File, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsDialogW2File)
	ON_BN_CLICKED(IDC_W2FBROWSE, OnBrowse)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_W2FFTP, OnBnClickedW2fftp)
	ON_BN_CLICKED(IDC_W2FENABLE, OnBnClickedW2fenable)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogW2File message handlers

BOOL CSettingsDialogW2File::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_SETTINGS_W2FILE);
	m_Helper.translateDlgItemText(this, IDC_LW2FEXIT);
	m_Helper.translateDlgItemText(this, IDC_LW2FFILENAME);
	m_Helper.translateDlgItemText(this, IDC_LW2FFORMAT);
	m_Helper.translateDlgItemText(this, IDC_LW2FPAUSE);
	m_Helper.translateDlgItemText(this, IDC_LW2FPLAY);
	m_Helper.translateDlgItemText(this, IDC_LW2FSTOP);
	m_Helper.translateDlgItemText(this, IDC_W2FENABLE);
	m_Helper.translateDlgItemText(this, IDC_W2FDELONEXIT);
	m_Helper.translateDlgItemText(this, IDC_W2FOEM);
	m_Helper.translateDlgItemText(this, IDC_W2FBROWSE);
	m_Helper.translateDlgItemText(this, IDC_W2FFTP);
	m_Helper.translateDlgItemText(this, IDC_LUPLOADONFTP);
	m_Helper.translateDlgItemText(this, IDC_LW2FSITE);
	m_Helper.translateDlgItemText(this, IDC_LW2FUSER);
	m_Helper.translateDlgItemText(this, IDC_LW2FPASSWORD);

	m_file = pMainFrame->W2Ffile;

	m_play = pMainFrame->W2Fplay;
	m_pause = pMainFrame->W2Fpause;
	m_stop = pMainFrame->W2Fstop;
	m_exit = pMainFrame->W2Fexit;


	m_play.Replace(_T("\\r"), _T("\r"));
	m_play.Replace(_T("\\n"), _T("\n"));

	m_pause.Replace(_T("\\r"), _T("\r"));
	m_pause.Replace(_T("\\n"), _T("\n"));

	m_stop.Replace(_T("\\r"), _T("\r"));
	m_stop.Replace(_T("\\n"), _T("\n"));

	m_exit.Replace(_T("\\r"), _T("\r"));
	m_exit.Replace(_T("\\n"), _T("\n"));

	m_oem = pMainFrame->W2Foem;
	m_del = pMainFrame->W2Fdel;
	m_enabled = pMainFrame->W2Fenabled;
	m_Ftp = pMainFrame->W2FFtp;
	m_Site = pMainFrame->W2FSite;
	m_User = pMainFrame->W2FUser;
	m_Password = pMainFrame->W2FPassword;

	GetDlgItem(IDC_W2FFILE)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FSITE)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FUSER)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FBROWSE)->EnableWindow(!m_Ftp);

	OnBnClickedW2fenable();

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogW2File::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->W2Ffile = m_file;
	pMainFrame->W2Fplay = m_play;
	pMainFrame->W2Fpause = m_pause;
	pMainFrame->W2Fstop = m_stop;
	pMainFrame->W2Fexit = m_exit;

	pMainFrame->W2Fplay.Replace(_T("\r"), _T("\\r"));
	pMainFrame->W2Fplay.Replace(_T("\n"), _T("\\n"));

	pMainFrame->W2Fpause.Replace(_T("\r"), _T("\\r"));
	pMainFrame->W2Fpause.Replace(_T("\n"), _T("\\n"));

	pMainFrame->W2Fstop.Replace(_T("\r"), _T("\\r"));
	pMainFrame->W2Fstop.Replace(_T("\n"), _T("\\n"));

	pMainFrame->W2Fexit.Replace(_T("\r"), _T("\\r"));
	pMainFrame->W2Fexit.Replace(_T("\n"), _T("\\n"));

	pMainFrame->W2Foem = m_oem;
	pMainFrame->W2Fdel = m_del;
	pMainFrame->W2Fenabled = m_enabled;
	pMainFrame->W2FFtp = m_Ftp;
	pMainFrame->W2FSite = m_Site;
	pMainFrame->W2FUser = m_User;
	pMainFrame->W2FPassword = m_Password;

	CPropertyPage::OnOK();
}

void CSettingsDialogW2File::OnBrowse()
{
	CFileDialog dialog(FALSE, _T("txt"), _T(""), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_OPENW2FFILE));

	if (dialog.DoModal() == IDOK)
	{
		m_file = dialog.GetPathName();
		UpdateData(FALSE);
	}
}

void CSettingsDialogW2File::OnBnClickedW2fftp()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_W2FFILE)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FSITE)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FUSER)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_Ftp);
	GetDlgItem(IDC_W2FBROWSE)->EnableWindow(!m_Ftp);
}
void CSettingsDialogW2File::OnBnClickedW2fenable()
{
	UpdateData(TRUE);

	GetDlgItem(IDC_W2FBROWSE)->EnableWindow(m_enabled && !m_Ftp);
	GetDlgItem(IDC_W2FFTP)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FFILE)->EnableWindow(m_enabled && m_Ftp);
	GetDlgItem(IDC_W2FSITE)->EnableWindow(m_enabled && m_Ftp);
	GetDlgItem(IDC_W2FUSER)->EnableWindow(m_enabled && m_Ftp);
	GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_enabled && m_Ftp);
	GetDlgItem(IDC_W2FPLAY)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FPAUSE)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FSTOP)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FEXIT)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FOEM)->EnableWindow(m_enabled);
	GetDlgItem(IDC_W2FDELONEXIT)->EnableWindow(m_enabled);
}
