// SysTrayPlay.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "mainwnd.h"
#include "WAEmuWnd.h"
#include "PlaylistDlg.h"
#include "Tools/Console.h"
#include "MemLeakDetect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSysTrayPlayApp theApp;

// Detect Memory Leaks

#ifdef _DEBUGA
CMemLeakDetect memLeakDetect;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSysTrayPlayApp construction

CSysTrayPlayApp::CSysTrayPlayApp()
{
	hMutex = NULL;

	TCHAR profname[MAX_PATH];

	GetModuleFileName(m_hInstance, profname, MAX_PATH);
	for (int i = _tcslen(profname) - 1; i > 0; i--)
	{
		if (profname[i] == '.')
		{
			profname[i + 1] = 'i';
			profname[i + 2] = 'n';
			profname[i + 3] = 'i';
			profname[i + 4] = '\0';
			break;
		}
	}

	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(profname);
}

/////////////////////////////////////////////////////////////////////////////
// CSysTrayPlayApp initialization

int CSysTrayPlayApp::ExitInstance()
{
	// Release mutex
	if (hMutex != NULL)
		ReleaseMutex(hMutex);
	// Release mutex winamp
	if (hMutexWinamp != NULL)
		ReleaseMutex(hMutexWinamp);

	// Release the wndclass name
	if (bClassRegistered)
		::UnregisterClass(_T("STPAppClass"), AfxGetInstanceHandle());
	// Release the wndclass name winamp
	if (bClassRegisteredWinamp)
		if (AfxGetApp()->GetProfileInt(_T("Preferences"), _T("WAEmu"), 0) == 1)
			::UnregisterClass(_T("Winamp v1.x"), AfxGetInstanceHandle());
		else
			::UnregisterClass(_T("STPAppClass v1.x"), AfxGetInstanceHandle());
	CMenuXP::UninitializeHook();
	if (WAEmuWnd != NULL && WAEmuWnd->m_hWnd != NULL)
		WAEmuWnd->DestroyWindow();
	if (WAEmuWnd != NULL)
		delete WAEmuWnd;
	if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
		PlaylistDlg->DestroyWindow();
	if (PlaylistDlg != NULL)
		delete PlaylistDlg;
	PlaylistDlg = NULL;
	if (pMainFrame != NULL && pMainFrame->m_hWnd != NULL)
		pMainFrame->DestroyWindow();
	if (pMainFrame != NULL)
		delete pMainFrame;

	pConsole->Destroy();
	delete pConsole;
	return CWinApp::ExitInstance();
}
BOOL CSysTrayPlayApp::InitInstance()
{
	pConsole = new Console;
	CMenuXP::InitializeHook();
	hMutex = CreateMutex(NULL, FALSE, _T("STPAppClass"));
	if (AfxGetApp()->GetProfileInt(_T("Preferences"), _T("WAEmu"), 0) == 1)
		hMutexWinamp = CreateMutex(NULL, FALSE, _T("Winamp v1.x"));
	else
		hMutexWinamp = CreateMutex(NULL, FALSE, _T("STPAppClass v1.x"));

	struct CmdLineStruct
	{
		CString fname;
		bool AddFlag;
		bool ExitFlag;
		bool RestartFlag;
	} CmdLine;
	CmdLine.fname = _T("");
	CmdLine.AddFlag = false;
	CmdLine.ExitFlag = false;
	CmdLine.RestartFlag = false;
	CString tmp, tmp1;	
	for (int i = 1; i < __argc; i++)
	{
		LPCTSTR pszParam = __targv[i];
		tmp1.Format(_T(" %s"), pszParam);
		tmp += tmp1;

		BOOL bFlag = FALSE;
		if (pszParam[0] == '-')
		{
			// remove flag specifier
			bFlag = TRUE;
			pszParam++;
		}
		if (bFlag)
		{
			if (_tcscmp(pszParam, _T("?")) == 0)
			{
				AfxMessageBox(_T("STP command line :\n -a : Add a file/directory/playlist\n -x : Exit STP"), MB_OK);
				return FALSE;
			}
			else if (_tcscmp(pszParam, _T("a")) == 0)
				CmdLine.AddFlag = true;
			else if (_tcscmp(pszParam, _T("x")) == 0)
				CmdLine.ExitFlag = true;
			else if (_tcscmp(pszParam, _T("restart")) == 0)
				CmdLine.RestartFlag = true;
		}
		else
		{
			if (CmdLine.fname == _T(""))
				CmdLine.fname = pszParam;
		}
	}
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		if (CmdLine.fname != "" || CmdLine.ExitFlag)
		{
			HWND hPrevWnd;
			if (CmdLine.ExitFlag)
			{
				if ((hPrevWnd = ::FindWindow(_T("STPAppClass"), NULL)) != NULL)
					::SendMessage(hPrevWnd, WM_COMMAND, (WPARAM)ID_POPUPMENU_EXIT, (LPARAM)NULL);
			}
			else
			{
				MsgCmd cmd;
				COPYDATASTRUCT cds;
				cds.dwData = 0;
				cds.cbData = sizeof(cmd);
				cds.lpData = &cmd;
				if (CmdLine.fname != "")
				{
					if (CmdLine.AddFlag)
						cmd.command = 1;
					else
						cmd.command = 0;
					_tcscpy(cmd.fname, (TCHAR *)CmdLine.fname.GetString());
				}
				else
					cmd.command = 2;
				for (int i = 0; i < 50; i++)
				{
					if ((hPrevWnd = ::FindWindow(_T("STPAppClass"), NULL)) != NULL)
						if (::SendMessage(hPrevWnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds))
							break;
					Sleep(100);
				}
			}
		}
		if (CmdLine.RestartFlag)
		{
			HWND hPrevWnd;
			if ((hPrevWnd = ::FindWindow(_T("STPAppClass"), NULL)) != NULL)
			{
				while (IsWindow(hPrevWnd))
					Sleep(100);
			}
			else
				return FALSE;
		}
		else
			return FALSE;
	}

	WNDCLASS wndcls;
	memset(&wndcls, 0, sizeof(WNDCLASS));

	wndcls.lpfnWndProc = ::DefWindowProc;
	wndcls.hInstance = AfxGetInstanceHandle();
	wndcls.hIcon = LoadIcon(IDI_STP);
	wndcls.hCursor = LoadCursor(IDC_ARROW);
	wndcls.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wndcls.lpszMenuName = NULL;

	wndcls.lpszClassName = _T("STPAppClass");

	if (!AfxRegisterClass(&wndcls))
		return FALSE;
	bClassRegistered = TRUE;

	pMainFrame = new CMainWnd;

	pMainFrame->Create(_T("STPAppClass"), _T("STP"));

	m_pMainWnd = pMainFrame;

	pConsole->Create();

	memset(&wndcls, 0, sizeof(WNDCLASS));

	wndcls.lpfnWndProc = ::DefWindowProc;
	wndcls.hInstance = AfxGetInstanceHandle();
	wndcls.lpszMenuName = NULL;


	// Specify our own class name for using FindWindow later
	if (AfxGetApp()->GetProfileInt(_T("Preferences"), _T("WAEmu"), 0) == 1)
		wndcls.lpszClassName = _T("Winamp v1.x");
	else
		wndcls.lpszClassName = _T("STPAppClass v1.x");
	if (!AfxRegisterClass(&wndcls))
		return FALSE;

	bClassRegisteredWinamp = TRUE;

	WAEmuWnd = new CWAEmuWnd;
	if (AfxGetApp()->GetProfileInt(_T("Preferences"), _T("WAEmu"), 0) == 1)
		WAEmuWnd->CreateEx(WS_EX_TOPMOST | WS_EX_TOOLWINDOW, _T("Winamp v1.x"), _T(" - Winamp"), WS_POPUP, 0, ::GetSystemMetrics(SM_CYFULLSCREEN), 0, 0, NULL, NULL, NULL);
	else
		WAEmuWnd->CreateEx(WS_EX_TOPMOST | WS_EX_TOOLWINDOW, _T("STPAppClass v1.x"), _T(" - STPAppClass"), WS_POPUP, 0, ::GetSystemMetrics(SM_CYFULLSCREEN), 0, 0, NULL, NULL, NULL);
	WAEmuWnd->ShowWindow(SW_NORMAL);
	PlaylistDlg = PlaylistDlg->getInstance();
	PlaylistDlg->ShowWindow(SW_HIDE);
	pMainFrame->Start2();
	if (CmdLine.fname != "" || CmdLine.ExitFlag)
	{
		if (CmdLine.ExitFlag)
			::SendMessage(pMainFrame->m_hWnd, WM_COMMAND, (WPARAM)ID_POPUPMENU_EXIT, (LPARAM)NULL);
		else
		{
			MsgCmd cmd;
			COPYDATASTRUCT cds;
			cds.dwData = 0;
			cds.cbData = sizeof(cmd);
			cds.lpData = &cmd;
			if (CmdLine.fname != "")
			{
				if (CmdLine.AddFlag)
					cmd.command = 1;
				else
					cmd.command = 0;
				_tcscpy(cmd.fname, (TCHAR *)CmdLine.fname.GetString());
			}
			else
				cmd.command = 2;
			::SendMessage(pMainFrame->m_hWnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds);
		}
	}
	return TRUE;
}
