#ifndef FACTORY_H
#define FACTORY_H

#include "config.h"
#include <api/service/waservicefactory.h>

class CFactory : public waServiceFactory
{
	CConfig config;
	GUID guid;
public :
	CFactory(GUID nGuid)
	{
		guid = nGuid;
	};

	FOURCC _getServiceType();
	const char* _getServiceName();
	GUID _getGuid();
	void* _getInterface(int global_lock = TRUE);
	int _supportNonLockingGetInterface();
	int _releaseInterface(void* ifc);
	const wchar_t* _getTestString();
	int _serviceNotify(int msg, int param1 = 0, int param2 = 0);

#undef CBCLASS
#define CBCLASS CFactory
	START_DISPATCH;
	CB(WASERVICEFACTORY_GETSERVICETYPE, _getServiceType);
	CB(WASERVICEFACTORY_GETSERVICENAME, _getServiceName);
	CB(WASERVICEFACTORY_GETGUID, _getGuid);
	CB(WASERVICEFACTORY_GETINTERFACE, _getInterface);
	CB(WASERVICEFACTORY_SUPPORTNONLOCKINGGETINTERFACE, _supportNonLockingGetInterface);
	CB(WASERVICEFACTORY_RELEASEINTERFACE, _releaseInterface);
	CB(WASERVICEFACTORY_GETTESTSTRING, _getTestString);
	CB(WASERVICEFACTORY_SERVICENOTIFY, _serviceNotify);
	END_DISPATCH;
#undef CBCLASS
};


#endif