// MP3InfoDlg.cpp : implementation file
//

#include "../stdafx.h"
#include "../resource.h"   	// main symbols
#include <wa_ipc.h>
#include "in_mpg123.h"
#include "TagInfo.h"
#include "MP3InfoDlg.h"
#include "../MainHelper.h"
#include "../MP3ID3.h"
#include "../PlaylistManager.h"
#include "MultiDllInput.h"
#include "../WAEmuWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CStringArray genres;
CMP3InfoDlg* MP3InfoDlg = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg dialog


CMP3InfoDlg::CMP3InfoDlg(CString fileName, BOOL mode) : CDialog(CMP3InfoDlg::IDD)
{
	m_filename = fileName;
	editMode = mode;
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_album2 = _T("");
	m_artist2 = _T("");
	m_comment2 = _T("");
	m_albumartist2 = _T("");
	m_composer2 = _T("");
	m_origartist2 = _T("");
	m_copyright2 = _T("");
	m_url2 = _T("");
	m_encoded2 = _T("");
	m_disc2 = _T("");
	m_genre = _T("");
	m_title = _T("");
	m_year = _T("");
	m_genre2 = _T("");
	m_title2 = _T("");
	m_year2 = _T("");
	m_bitrate = _T("");
	m_freq = _T("");
	m_mode = _T("");
}

CMP3InfoDlg::~CMP3InfoDlg()
{
	MP3InfoDlg = NULL;
}

CMP3InfoDlg* CMP3InfoDlg::getInstance(CString fileName, BOOL mode)
{
	if (MP3InfoDlg != NULL)
	{
		if (MP3InfoDlg->m_hWnd != NULL)
		{
			MP3InfoDlg->DestroyWindow();
		}
		delete MP3InfoDlg;
		MP3InfoDlg = NULL;
	}
	if (MP3InfoDlg == NULL)
	{
		MP3InfoDlg = new CMP3InfoDlg(fileName, mode);
		MP3InfoDlg->Create(CMP3InfoDlg::IDD);
	}
	return MP3InfoDlg;
}

IMPLEMENT_MENUXP(CMP3InfoDlg, CDialog)

BEGIN_MESSAGE_MAP(CMP3InfoDlg, CDialog)
ON_BN_CLICKED(IDC_EDITTAG, OnEditTag)
ON_MENUXP_MESSAGES()
ON_WM_CLOSE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg message handlers

void CMP3InfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, GetProfileInt(_T("Preferences"), _T("XPLookNFeel"), FALSE));
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_ALBUM2, m_album2);
	DDX_Text(pDX, IDC_EDIT_ARTIST2, m_artist2);
	DDX_Text(pDX, IDC_EDIT_COMMENT2, m_comment2);	
	DDX_Text(pDX, IDC_EDIT_ALBUMARTIST2, m_albumartist2);
	DDX_Text(pDX, IDC_EDIT_COMPOSER2, m_composer2);
	DDX_Text(pDX, IDC_EDIT_ORIGARTIST2, m_origartist2);
	DDX_Text(pDX, IDC_EDIT_COPYRIGHT2, m_copyright2);
	DDX_Text(pDX, IDC_EDIT_URL2, m_url2);
	DDX_Text(pDX, IDC_EDIT_ENCODED2, m_encoded2);
	DDX_Text(pDX, IDC_EDIT_DISC2, m_disc2);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Text(pDX, IDC_EDIT_GENRE2, m_genre2);
	DDX_Text(pDX, IDC_EDIT_TITLE2, m_title2);
	DDX_Text(pDX, IDC_EDIT_YEAR2, m_year2);

	DDX_Control(pDX, IDC_EDIT_ALBUM, m_c_album);
	DDX_Control(pDX, IDC_EDIT_ARTIST, m_c_artist);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_c_comment);
	DDX_Control(pDX, IDC_EDIT_ALBUM2, m_c_album2);
	DDX_Control(pDX, IDC_EDIT_ARTIST2, m_c_artist2);
	DDX_Control(pDX, IDC_EDIT_COMMENT2, m_c_comment2);
	DDX_Control(pDX, IDC_EDIT_ALBUMARTIST2, m_c_albumartist2);
	DDX_Control(pDX, IDC_EDIT_COMPOSER2, m_c_composer2);
	DDX_Control(pDX, IDC_EDIT_ORIGARTIST2, m_c_origartist2);
	DDX_Control(pDX, IDC_EDIT_COPYRIGHT2, m_c_copyright2);
	DDX_Control(pDX, IDC_EDIT_URL2, m_c_url2);
	DDX_Control(pDX, IDC_EDIT_ENCODED2, m_c_encoded2);
	DDX_Control(pDX, IDC_EDIT_DISC2, m_c_disc2);
	DDX_Control(pDX, IDC_EDIT_FILENAME, m_c_filename);
	DDX_Control(pDX, IDC_EDIT_GENRE, m_c_genre);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_c_title);
	DDX_Control(pDX, IDC_EDIT_YEAR, m_c_year);
	DDX_Control(pDX, IDC_EDIT_GENRE2, m_c_genre2);
	DDX_Control(pDX, IDC_EDIT_TITLE2, m_c_title2);
	DDX_Control(pDX, IDC_EDIT_YEAR2, m_c_year2);

	DDX_Text(pDX, IDC_EDIT_BITRATE, m_bitrate);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_freq);
	DDX_Text(pDX, IDC_EDIT_MODE, m_mode);
	DDX_Control(pDX, IDC_EDITTAG, m_btn_EditTag);
	DDX_Control(pDX, IDOK, m_btn_Ok);
	DDX_Control(pDX, IDCANCEL, m_btn_Cancel);
}


void CMP3InfoDlg::ReadInfo()
{
	CString mbuf = "";
	m_bitrate = mbuf.Left(mbuf.Find('@'));
	mbuf = mbuf.Mid(mbuf.Find('@') + 1);
	m_freq = mbuf.Left(mbuf.Find('@'));
	m_mode = mbuf.Mid(mbuf.Find('@') + 1);

	if (PrevFile == m_filename)
	{
		UpdateData(FALSE);
		return;
	}
	PrevFile = m_filename;
	wcscpy(info.FileName, m_filename);
	wcscpy(info2.FileName, m_filename);

	info.Album[0] = '\0';
	info.Artist[0] = '\0';
	info.Comment[0] = '\0';
	info.Genre[0] = '\0';
	info.Title[0] = '\0';
	info.Year[0] = '\0';
	info2.Album[0] = '\0';
	info2.Artist[0] = '\0';
	info2.Comment[0] = '\0';
	info2.AlbumArtist[0] = '\0';
	info2.Composer[0] = '\0';
	info2.OrgArtist[0] = '\0';
	info2.Copyright[0] = '\0';
	info2.Url[0] = '\0';
	info2.Encoder[0] = '\0';
	info2.Disc[0] = '\0';
	info2.Genre[0] = '\0';
	info2.Title[0] = '\0';
	info2.Year[0] = '\0';

	m_Tag.GetTitleFromID3v1(&info);
	m_Tag.GetTitleFromID3v2(&info2);

	m_album = info.Album;
	m_artist = info.Artist;
	m_comment = info.Comment;
	m_genre = info.Genre;
	m_title = info.Title;
	m_year = info.Year;
	m_album2 = info2.Album;
	m_artist2 = info2.Artist;
	m_comment2 = info2.Comment;
	m_albumartist2 = info2.AlbumArtist;
	m_composer2 = info2.Composer;
	m_origartist2 = info2.OrgArtist;
	m_copyright2 = info2.Copyright;
	m_url2 = info2.Url;
	m_encoded2 = info2.Encoder;
	m_disc2 = info2.Disc;
	m_genre2 = info2.Genre;
	m_title2 = info2.Title;
	m_year2 = info2.Year;

	UpdateData(false);
}

void CMP3InfoDlg::OnEditTag()
{
	ChangeEditMode(TRUE);
}
void CMP3InfoDlg::ChangeEditMode(BOOL mode)
{
	editMode = mode;
	m_c_album.SetReadOnly(!editMode);
	m_c_artist.SetReadOnly(!editMode);
	m_c_comment.SetReadOnly(!editMode);
	m_c_title.SetReadOnly(!editMode);
	m_c_year.SetReadOnly(!editMode);
	m_c_genre.SetReadOnly(!editMode);
	m_c_album2.SetReadOnly(!editMode);
	m_c_artist2.SetReadOnly(!editMode);
	m_c_comment2.SetReadOnly(!editMode);
	m_c_composer2.SetReadOnly(!editMode);
	m_c_albumartist2.SetReadOnly(!editMode);
	m_c_origartist2.SetReadOnly(!editMode);
	m_c_copyright2.SetReadOnly(!editMode);
	m_c_url2.SetReadOnly(!editMode);
	m_c_encoded2.SetReadOnly(!editMode);
	m_c_disc2.SetReadOnly(!editMode);
	m_c_title2.SetReadOnly(!editMode);
	m_c_year2.SetReadOnly(!editMode);
	m_c_genre2.SetReadOnly(!editMode);
	m_btn_EditTag.ShowWindow(editMode ? SW_HIDE : SW_SHOW);
	m_btn_Ok.ShowWindow(editMode ? SW_SHOW : SW_HIDE);
	m_btn_Cancel.ShowWindow(editMode ? SW_SHOW : SW_HIDE);
}

BOOL CMP3InfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_DIALOG_MP3INFO);
	m_Helper.translateDlgItemText(this, IDC_LFILENAME);
	m_Helper.translateDlgItemText(this, IDC_LBITRATE);
	m_Helper.translateDlgItemText(this, IDC_LKBPS);
	m_Helper.translateDlgItemText(this, IDC_LFREQ);
	m_Helper.translateDlgItemText(this, IDC_LHZ);
	m_Helper.translateDlgItemText(this, IDC_LMODE);
	m_Helper.translateDlgItemText(this, IDC_LTITLE);
	m_Helper.translateDlgItemText(this, IDC_LARTIST);
	m_Helper.translateDlgItemText(this, IDC_LALBUM);
	m_Helper.translateDlgItemText(this, IDC_LYEAR);
	m_Helper.translateDlgItemText(this, IDC_LCOMMENT);
	m_Helper.translateDlgItemText(this, IDC_LGENRE);
	m_Helper.translateDlgItemText(this, IDC_LTITLE2);
	m_Helper.translateDlgItemText(this, IDC_LARTIST2);
	m_Helper.translateDlgItemText(this, IDC_LALBUM2);
	m_Helper.translateDlgItemText(this, IDC_LYEAR2);
	m_Helper.translateDlgItemText(this, IDC_LCOMMENT2);
	m_Helper.translateDlgItemText(this, IDC_LALBUMARTIST2);
	m_Helper.translateDlgItemText(this, IDC_LGENRE2);
	m_Helper.translateDlgItemText(this, IDC_LCOMPOSER2);
	m_Helper.translateDlgItemText(this, IDC_LORIGARTIST2);
	m_Helper.translateDlgItemText(this, IDC_LCOPYRIGHT2);
	m_Helper.translateDlgItemText(this, IDC_LURL2);
	m_Helper.translateDlgItemText(this, IDC_LENCODED2);
	m_Helper.translateDlgItemText(this, IDC_LDISC2);
	m_Helper.translateDlgItemText(this, IDC_EDITTAG);

	PrevFile = "*";
	ReadInfo();
	ChangeEditMode(editMode);

	return TRUE;
}

void CMP3InfoDlg::OnOK()
{
	UpdateData(true);
	int pos = -1;
	if (m_filename == m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current))
	{
		pos = stdIn->GetOutputTime();
		stdIn->Stop();
	}
	DWORD attrs = ::GetFileAttributes(m_filename);
	::SetFileAttributes(m_filename, attrs & !FILE_ATTRIBUTE_READONLY);

	CMP3ID3 test;

	TCHAR path[MAX_PATH];
	_tcscpy(path, m_filename.GetString());

	test.prepareMP3((char*)path, false);
	test.setTitle((unsigned char*)m_title.GetString());
	test.setArtist((unsigned char*)m_artist.GetString());
	test.setAlbum((unsigned char*)m_album.GetString());
	test.setYear((unsigned char*)m_year.GetString());
	test.setComment((unsigned char*)m_comment.GetString());
	CString buf;
	/*	if(m_genre != -1)
		{
			m_c_genre.GetLBText(m_genre, buf);
			test.setGenre((unsigned char *)buf.GetString());
		}
	*/	test.update();

	ChangeEditMode(FALSE);
	ReadInfo();
	if (m_filename == m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current))
	{
		stdIn->Play((TCHAR *)m_filename.GetString());
		stdIn->SetOutputTime(pos);
		m_PlaylistManager.ReadTagAT(m_PlaylistManager.Current, true);
	}
	else
	{
		int index = m_PlaylistManager.GetIndex(m_filename);
		m_PlaylistManager.ReadTagAT(index, true);
	}
}

void CMP3InfoDlg::OnCancel()
{
	ChangeEditMode(FALSE);
	ReadInfo();
}

void CMP3InfoDlg::OnClose()
{
	CDialog::OnCancel();
}